package org.processmining.visualpetrinetanalyzer.dialogs;

import info.clearthought.layout.TableLayout;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.processmining.visualpetrinetanalyzer.parameters.Axis;
import org.processmining.visualpetrinetanalyzer.parameters.CalculationMethod;
import org.processmining.visualpetrinetanalyzer.parameters.VisualPetrinetModelParameters;
import org.processmining.visualpetrinetanalyzer.parameters.Visualization;

import com.fluxicon.slickerbox.factory.SlickerFactory;

public class VisualPetrinetMiningDialog extends JPanel {

	private static final long serialVersionUID = 1L;

	public VisualPetrinetMiningDialog(final VisualPetrinetModelParameters parameters) {

		double size[][] = { { 300, 200 }, { 30, 30, 30, 30, 30, 30 } };
		setLayout(new TableLayout(size));

		final JComboBox<Visualization> visualization = new JComboBox<Visualization>();		
		for(Visualization option : Visualization.values()) {
			visualization.addItem(option);
		}
		
		visualization.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				parameters.visualization = (Visualization)visualization.getSelectedItem();
			}			
		});
		visualization.setSelectedItem(parameters.visualization);
		JLabel visualizationLabel = new JLabel("Visualization type");
	    
		final JComboBox<CalculationMethod> calculationMethod = new JComboBox<CalculationMethod>();		
		for(CalculationMethod option : CalculationMethod.values()) {
			calculationMethod.addItem(option);
		}
		
		calculationMethod.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				parameters.calculationMethod = (CalculationMethod)calculationMethod.getSelectedItem();
			}			
		});
		calculationMethod.setSelectedItem(parameters.calculationMethod);
        JLabel calculationLabel = new JLabel("Time calculation method");
	    
		final JComboBox<Axis> axis = new JComboBox<Axis>();		
		for(Axis option : Axis.values()) {
			axis.addItem(option);
		}
		
		axis.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				parameters.axis = (Axis)axis.getSelectedItem();
			}			
		});
		axis.setSelectedItem(parameters.axis);
        JLabel axisLabel = new JLabel("Scale of the axis");
		

		add(SlickerFactory.instance().createLabel("<html><h2>Select visual parameters</h2>"), "0, 0");
		
		add(visualizationLabel, "0 1");
		add(visualization, "1, 1");
		
		add(calculationLabel, "0, 3");
		add(calculationMethod, "1, 3");
		
		add(axisLabel, "0, 5");
		add(axis, "1, 5");
	}
}
