package org.processmining.visualpetrinetanalyzer.models;

import java.util.ArrayList;
import java.util.List;

public class Description {
	private String target;
	private String source;
	private List<String> items;

	public Description(String target, String source) {
		this(target);
		this.source = source;
	}

	public Description(String target) {
		this.target = target;
		this.items = new ArrayList<String>();
	}
	
	public void AddItem(String item) {
		items.add(item);
	}

	public String getHeader() {
		String header = "";
		if(source != null) { 
			header += source + " -> " + target;
		} else {
			header += target;			
		}
		return header;
	}
	
	public List<String> getItems() {
		return items;
	}
	
	public List<String> getAllTextItems() {
		List<String>  allItems = new ArrayList<String>();
		if (target != null) allItems.add(target);
		if (source != null) allItems.add(source);
		allItems.addAll(items);
		return allItems;
	}
	
	public String getHTMLTooltip() {
		String html = "<html><b>" + getHeader() + "</b>";
		for(String item : items) {
			html +=  "<br>" + item;
		}		
		html += "</html>";
		return html;
	}
}
